<script setup lang="ts">
import type { BaseCard } from '@/types/base';
import { OpenSource, ChevronLgRight } from 'slippers-ui/icons';

const icons = { OpenSource };

interface CardWithType extends BaseCard {
  type?: string;
}

interface CardGridProps {
  title?: string;
  description?: string;
  cards: Array<CardWithType>;
  config?: { columns: number; icon?: string; id?: string };
}

defineProps<CardGridProps>();
</script>

<template>
  <section class="slp-pt-md-96 solutions-card-grid">
    <SlpContainer :id="config?.id">
      <SlpIcon v-if="config?.icon" :icon="icons[config.icon]" size="lg" class="slp-mb-16 icon" />
      <SlpTypography variant="heading2-bold" tag="h2" class="slp-mb-24">
        {{ title }}
      </SlpTypography>
      <SlpTypography variant="body2" tag="p" class="slp-pb-16">
        {{ description }}
      </SlpTypography>
      <SlpRow class="card-container">
        <SlpColumn v-for="card in cards" :key="card.title" :cols="config?.columns">
          <div class="card">
            <div>
              <SlpTypography v-if="card.type" tag="p" variant="body1" class="slp-mb-16">
                {{ card.type }}
              </SlpTypography>
              <SlpTypography tag="h5" variant="heading5-bold" class="slp-mb-16">
                {{ card.title }}
              </SlpTypography>
              <div class="slp-mt-16 description" v-html="$md.render(card.description)" />
            </div>
            <div class="card-button-container">
              <!-- eslint-disable-next-line dex-data-properties/require-data-ga-attributes -->
              <SlpButton v-if="card.button" variant="tertiary" :href="card.button.config?.href">
                {{ card.button?.text }}<SlpIcon :icon="ChevronLgRight" alt="" />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.solutions-card-grid {
  .icon {
    background-color: $color-surface-900;
    border-radius: 50%;
    padding: $spacing-4;
  }

  .card-container {
    padding-bottom: $spacing-96;
    margin: 0 -#{$spacing-16};

    [class*='slp-col-'] {
      padding: 0 $spacing-16;
      margin-bottom: $spacing-32;
    }

    .card {
      flex: 0 1 250px;
      color: inherit;
      display: flex;
      border-radius: 4px;
      flex-direction: column;
      align-items: flex-start;
      justify-content: space-between;
      padding: $spacing-32 $spacing-24;
      background: $color-surface-50;
      z-index: 1;
      position: relative;
      width: 100%;
      height: 100%;
      background: $color-surface-800;
      transition: border-radius 0.3s $interactive-ease;

      @media (max-width: $breakpoint-md) {
        flex-grow: 1;
      }

      :deep(a) {
        color: $color-text-200;
        text-decoration: underline;
      }

      .description {
        font-size: 16px;
        color: $color-text-200;
      }

      .slp-btn {
        font-size: 14px;
        padding: $spacing-16 0;
        text-align: left;
        color: $color-text-300;
        text-decoration: none;
      }
    }
  }
}
</style>
